package com.shiyanlou.service.impl;


import com.shiyanlou.dao.entity.Admin;
import com.shiyanlou.dao.repository.AdminRepository;
import com.shiyanlou.service.RbacService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.stereotype.Component;
import org.springframework.util.AntPathMatcher;

import javax.servlet.http.HttpServletRequest;
import java.util.Set;

@Component("rbacService")
public class RbacServiceImpl implements RbacService {

    private AntPathMatcher antPathMatcher = new AntPathMatcher();

    @Autowired
    private AdminRepository adminRepository;

    @Override
    public boolean hasPermission(HttpServletRequest request, Authentication authentication) {
        Object principal = authentication.getPrincipal();

        boolean hasPermission = false;

        if (principal instanceof String) {

            Admin admin = adminRepository.findByUsername(String.valueOf(principal));


            // 读取用户所拥有权限的所有URL
            Set<String> urls = (admin).getUrls();
            for (String url : urls) {

                if (antPathMatcher.match(url, request.getRequestURI())) {
                    hasPermission = true;
                    break;
                }

                break;
            }
        }
        return hasPermission;
    }
}
